// ==UserScript==
// @name          webmoney.ru
// ==/UserScript==

function wmff_copy_field(name) {
	var result = '';
	var fields = document.getElementsByName(name);
	if (fields != null) {
		if (fields.length > 0) {
			result = '<input type="hidden" name="' + name + '" value="' + fields[0].value + '" />';
		}
	}
	return result;
}

function wmff_detect_action(loc) {
	var regex = new RegExp("\:\/\/(www\.)*([^\/]+)\/(lmi)*.*").exec(loc.toLowerCase());

	switch (regex[2]) {

		case "arbitrage.webmoney.ru":
			return "SignedLoginAction.asp?SP=Login.asp?";

		case "banking.webmoney.ru":
			return "NewSignedLoginAction.asp?SP=InputPayment%2Easp";

		case "cards.webmoney.ru":
			return "SignedLoginAction.asp?SP=";

		case "merchant.webmoney.ru":
			if (regex[3] == null)
				return "NewSignedLoginAction.asp?SP=default%2Easp&A=1";
			else
				return "NewSignedLoginAction.asp?SP=payment%5Fconf%2Easp%3Fa%3D1%26b%3D2";

		case "passport.webmoney.ru":
			return "SignedLoginAction.asp?SP=aProcess.asp?";

		case "security.webmoney.ru":
			return "NewSignedLoginAction.asp?SP=";

		case "notify.webmoney.ru":
			return "signedloginaction.asp?SP=tuning.asp";

		case "education.webmoney.ru":
			return "SignedLoginAction.asp?SP=Login.asp?";

		case "mail.wmkeeper.com":
			return "../src/redirect.php";

		case "wm.exchanger.ru":
			return "SignedLoginAction.asp?SP=";

		case "wire.exchanger.ru":
			return "reg_login.aspx";

		case "ecurrency.exchanger.ru":
			return "reg_login.aspx";

		case "credit.webmoney.ru":
			return "LoginForm.aspx";

		case "debt.wmtransfer.com":
			return "LoginForm.aspx";

		case "shareholder.ru":
			return "LoginForm.aspx";

		case "capitaller.ru":
			return "LoginForm.aspx";

		case "files.webmoney.ru":
			return "validate.php";

		case "megastock.ru":
			return "KeeperLogin.aspx";

		case "domains.webmoney.ru":
			return "/scripts/wmauth2.pl";

		case "geo.webmoney.ru":
			return "reg_login.aspx";


		default:
			return "";
	}
}


function wmff_init() {
	var content = document.getElementsByTagName("html")[0].innerHTML;
	var regex = new RegExp("(<access>.+<\/access>)").exec(content);

	if (regex != null) {
		var sSString = regex[1];

		AcceptWM = null;
		AcceptWM = new GeckoActiveXObject('WMAcceptor.AcceptWM');
		AcceptWM.nState = '2';

		var err = '';
		if(AcceptWM != null) {
			if(AcceptWM.strLoginName != 'not login') {
				readystatech = '2';
			} else {
				err = 'AcceptWM not logged in';
			}
		} else {
			err = 'AcceptWM not initialized';
		}

		if (err == '') {
			var curTime = new Date();
			var sCurTime = new String("");
			sCurTime += (curTime.getMonth()+1) + "/";
			sCurTime += curTime.getDate() + "/";
			sCurTime += curTime.getYear() + " ";
			sCurTime += curTime.getHours() + ":";
			sCurTime += curTime.getMinutes() + ":";
			sCurTime += curTime.getSeconds();

			var action = wmff_detect_action(document.location.href);
			var signstring = AcceptWM.SignString(sSString);

			var wmff_form = '';
			wmff_form += '<div style="position: absolute; top: 0; left: 0; padding: 4px; border: 1px solid #116699; background-color: #dbe2e9;">';
			wmff_form += '<form action="' + action + '" method="post" name="wmff" style="margin: 0;">';
			wmff_form += '<input type="hidden" name="WMID" value="' + AcceptWM.strLoginName + '" />';
			wmff_form += '<input type="hidden" name="signString" value="' + signstring + '" />';
			wmff_form += '<input type="hidden" name="SignStr" value="' + signstring + '" />';
			wmff_form += '<input type="hidden" name="curclienttime" value="' + sCurTime + '" />';
			wmff_form += '<input type="hidden" name="wmlogintype" value="1" />';

			wmff_form += wmff_copy_field("KeeperType");
			wmff_form += wmff_copy_field("B_Action");
			wmff_form += wmff_copy_field("ReturnURL");
			wmff_form += wmff_copy_field("__VIEWSTATE");
			wmff_form += wmff_copy_field("__EVENTVALIDATION");

			wmff_form += '<input type="image" src="https://passport.webmoney.ru/images/at100.gif" alt="" />';
			wmff_form += '</form>';
			wmff_form += '</div>';

			document.body.innerHTML = document.body.innerHTML + wmff_form;
		} else {
			var wmff_form = '';
			wmff_form += '<div style="position: absolute; top: 0; left: 0; padding: 4px; border: 1px solid #116699; background-color: #dbe2e9;">';

			wmff_form += '<img src="https://passport.webmoney.ru/images/gat100.gif" alt="' + err + '" title="' + err + '" />';
			wmff_form += '</div>';
			document.body.innerHTML = document.body.innerHTML + wmff_form;
		}

	}
}

window.addEventListener('load', wmff_init());
